<?php
/*
The script to check/convert forum anchored hyperlinks.
This file is part of miniBB. miniBB is free discussion forums/message board software, without any warranty.
Check COPYING file for more details.
Copyright (C) 2016 Paul Puzyrev. www.minibb.com
Latest File Update: 2016-Jun-27
*/
/* http://www.minibb.com/forums/msg.php?id=5569 */

define ('INCLUDED776',1);
//archives
//define('ARCHIVE', '2005-2009');

include('./setup_options.php');
include($pathToFiles.'setup_'.$DB.'.php');
include($pathToFiles.'bb_functions.php');

/* Important Settings - Change URL to your forum here! */

$quotePatterns=array(
0=>'#<a href="('.str_replace('.', '[.]', $main_url).')/(.*?)\#msg([0-9]+)"(.*?)>(.*?)</a>#',
1=>'#(.*?)<a href="http://www.minibb.com/forums/(.*?)\#msg([0-9]+)"(.*?)>(.*?)</a>#',
);
//set up this array, so msg number always belongs to the #3 pattern

$replacePatterns=array(
0=>'<a href="\\1/msg.php?id=\\3"\\4>\\5</a>',
1=>'<a href="http://www.minibb.com/forums/msg.php?id=\\3"\\4>\\5</a>',
);

$convertMode=FALSE; //TRUE - live update DB; FALSE - tests only

/* --Important Settings */


/* Optional Settings - they should do work with no modifying, and are for debugging/experienced coders only. */

$purgeSortOrder='topic_id ASC, post_id ASC';

$purgeTb=$Tp; //name of the posts table

$purgeField='post_text'; //name of the valuable field in the posts table

$purgeId='post_id'; //the unique ID of the posts table

$purgeFields='forum_id, topic_id';

$purgeGoPost='./msg.php?id=[POST_ID]';

$recordsLimit=30000; //the portion of selected records AT ONCE

$purgeLimited=FALSE; // the output will be limited to $recordsLimit amount only

/* --Optional Settings */


set_time_limit(0);

function get_microtime() {
$mtime=explode(' ',microtime());
return $mtime[1]+$mtime[0];
}

$starttime=get_microtime();
if(!defined('PAGE1_OFFSET')) define('PAGE1_OFFSET', 0);

$cnt=0;
$cntTotal=0;

$sql="select count(*) from {$purgeTb}";

if($res=mysqli_query($mysqlink, $sql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res)) $numRows=$row[0]; else $numRows=0;

echo <<<out
<!doctype html>
<html>
<head>
<title>Anchors Finding/Conversion</title>
<meta http-equiv="content-type" content="text/html;charset=iso-8859-1" />
<link href="{$main_url}/bb_default_style.css" type="text/css" rel="stylesheet">
</head>
<body class="gbody" style="background:#fff">
out;

function convert_quote($quotePatterns, $replacePatterns, $text){
$text=preg_replace($quotePatterns, $replacePatterns, $text);
return $text;
}

function extraSpacesBR($text){
$txt=preg_replace("#[ ]+<br>#", '<br>', $text);
$txt=preg_replace("#<br>[ ]+#", '<br>', $txt);
$txt=preg_replace("#<br>[\r\n]+#", '<br>', $txt);
$txt=preg_replace("#[\r\n]+<br>#", '<br>', $txt);
return $txt;
}

/*********************/

if(isset($_GET['action']) and $_GET['action']=='test'){

$post=(int)$_GET['post'];

$sql="select {$purgeId}, {$purgeField} from {$purgeTb}  where {$purgeId}={$post}";

if($res=mysqli_query($mysqlink, $sql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res)){

$quoteNew=convert_quote($quotePatterns, $replacePatterns, $row[1]);

//$quoteNew=extraSpacesBR($quoteNew);

echo $row[1].'<hr size="1"><br><h2>FIXED:</h2><br><div class="sp" style="background:#ffe">'.$quoteNew.'</div><hr size="1"><br><b>HTML</b>:<br><br>'.str_replace(array("\n", "\r"), '<br>', operate_string($quoteNew)).'<br><br>';

}

}

else{

echo 'Total Records: <b>'.$numRows.'</b><br /></b><br /><hr size="1" style="color:#ccc"><br />';

$cont='';

if($purgeLimited) $numRows=$recordsLimit;

if($numRows>0){

/****************/

$startOffset=0;
$currRec=0;
$supposeConverted=0;
$firstPageMsgs=0;
$nextPageMsgs=0;

while($startOffset<$numRows){

$sql="select {$purgeId}, {$purgeField}, {$purgeFields} from {$purgeTb} order by {$purgeSortOrder} limit {$startOffset}, {$recordsLimit}";

if($res=mysqli_query($mysqlink, $sql) and mysqli_num_rows($res)>0 and $row=mysqli_fetch_row($res)){

do{

$foundq=FALSE;
$idCurrent=$row[0];
$ptextCurrent=$row[1];
//$topic=$row[3];
//$tSize=round(strlen($ptextCurrent)/1024, 2).' Kb';

foreach($quotePatterns as $key=>$qp){
if(preg_match($qp, $ptextCurrent, $arr)) {

if(!$foundq) {

$detPostId=$arr[3];

//determining the msg page#
if(isset($themeDesc) and in_array($topic,$themeDesc)) $vv=TRUE; else $vv=FALSE;
if(!$vv) $sg='<='; else $sg='>=';

if($row2=db_simpleSelect(0, $purgeTb, 'topic_id', 'post_id', '=', $detPostId)) $topic=$row2[0]; else $topic=0;
if($row2=db_simpleSelect(0, $purgeTb, 'count(*)', 'post_id', $sg, $detPostId, '', '', 'topic_id', '=', $topic)) $pt=$row2[0]; else $pt=0;

if($pt<=$viewmaxreplys) {
$page=PAGE1_OFFSET+1;
$pb1='';$pb2='';
$firstPageMsgs++;
}
else {
$page=ceil($pt/$viewmaxreplys)+PAGE1_OFFSET;
$pb1='<b>';$pb2='</b>';
$nextPageMsgs++;
}

echo "<!--{$key} :: -->&nbsp;&nbsp;<a href=\"".str_replace('[POST_ID]', $idCurrent, $purgeGoPost)."\" target=\"_blank\">{$idCurrent}</a> [{$detPostId}--{$topic}] | <a href=\"./msg_convert.php?action=test&amp;post={$idCurrent}\" target=\"_blank\">Test</a> {$pb1}{$page}{$pb2}<br>";

if($convertMode){

$quoteNew=convert_quote($quotePatterns, $replacePatterns, $ptextCurrent);
$quoteNew=extraSpacesBR($quoteNew);

$sqlu="update {$purgeTb} set {$purgeField}='{$quoteNew}' where {$purgeId}={$idCurrent}";
mysqli_query($mysqlink, $sqlu) or die(mysqli_error($mysqlink));
}

}

$foundq=TRUE;

}
}

if($foundq) $supposeConverted++;

}
while($row=mysqli_fetch_row($res));


}


$startOffset=$startOffset+$recordsLimit;

}

/****************/

}

$ratio=floor($nextPageMsgs*100/($supposeConverted)).'%';

echo '<hr size="1"><br />Total Matched: '.$supposeConverted.'<br />Expected benefit ratio: <b>'.$ratio.'</b>';

$endtime=get_microtime();
$totaltime=sprintf ("%01.3f", ($endtime-$starttime));
echo '<br /><br />Total Time: '.$totaltime;

}

echo '</body></html>';

?>